<center><a href="fdmpiaij.c">Actual source code: fdmpiaij.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:23:20+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../../src/mat/impls/aij/mpi/mpiaij.h.html">src/mat/impls/aij/mpi/mpiaij.h</A>

<a name="line5">  5: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> CreateColmap_MPIAIJ_Private(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line6">  6: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatGetColumnIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*[],<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>*)</font></strong>;
<a name="line7">  7: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatRestoreColumnIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*[],<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>*)</font></strong>;

<a name="line11"> 11: </a><strong><font color="#4169E1"><a name="MatFDColoringCreate_MPIAIJ"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatFDColoringCreate_MPIAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> mat,<A href="../../../../../docs/manualpages/IS/ISColoring.html#ISColoring">ISColoring</A> iscoloring,<A href="../../../../../docs/manualpages/Mat/MatFDColoring.html#MatFDColoring">MatFDColoring</A> c)</font></strong>
<a name="line12"> 12: </a>{
<a name="line13"> 13: </a>  Mat_MPIAIJ     *aij = (Mat_MPIAIJ*)mat-&gt;data;
<a name="line15"> 15: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>,*ncolsonproc,*disp,nn;
<a name="line16"> 16: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,*is,n,nrows,j,k,m,*rows = 0,*A_ci,*A_cj,ncols,col;
<a name="line17"> 17: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       nis = iscoloring-&gt;n,nctot,*cols,*B_ci,*B_cj;
<a name="line18"> 18: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *rowhit,M = mat-&gt;rmap.n,cstart = mat-&gt;cmap.rstart,cend = mat-&gt;cmap.rend,colb;
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *columnsforrow,l;
<a name="line20"> 20: </a>  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>             *isa;
<a name="line21"> 21: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     done,flg;
<a name="line22"> 22: </a>  <A href="../../../../../docs/manualpages/IS/ISLocalToGlobalMapping.html#ISLocalToGlobalMapping">ISLocalToGlobalMapping</A> map = mat-&gt;mapping;
<a name="line23"> 23: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *ltog = map-&gt;indices,ctype=c-&gt;ctype;

<a name="line26"> 26: </a>  <font color="#4169E1">if</font> (!mat-&gt;assembled) {
<a name="line27"> 27: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONGSTATE,<font color="#666666">"Matrix must be assembled first; <A href="../../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>/End();"</font>);
<a name="line28"> 28: </a>  }

<a name="line30"> 30: </a>  <A href="../../../../../docs/manualpages/IS/ISColoringGetIS.html#ISColoringGetIS">ISColoringGetIS</A>(iscoloring,<A href="../../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,&amp;isa);
<a name="line31"> 31: </a>  c-&gt;M             = mat-&gt;rmap.N;  <font color="#B22222">/* set the global rows and columns and local rows */</font>
<a name="line32"> 32: </a>  c-&gt;N             = mat-&gt;cmap.N;
<a name="line33"> 33: </a>  c-&gt;m             = mat-&gt;rmap.n;
<a name="line34"> 34: </a>  c-&gt;rstart        = mat-&gt;rmap.rstart;

<a name="line36"> 36: </a>  c-&gt;ncolors       = nis;
<a name="line37"> 37: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nis*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;ncolumns);
<a name="line38"> 38: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nis*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*),&amp;c-&gt;columns);
<a name="line39"> 39: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nis*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;nrows);
<a name="line40"> 40: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nis*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*),&amp;c-&gt;rows);
<a name="line41"> 41: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nis*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*),&amp;c-&gt;columnsforrow);
<a name="line42"> 42: </a>  PetscLogObjectMemory(c,5*nis*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));

<a name="line44"> 44: </a>  <font color="#B22222">/* Allow access to data structures of local part of matrix */</font>
<a name="line45"> 45: </a>  <font color="#4169E1">if</font> (!aij-&gt;colmap) {
<a name="line46"> 46: </a>    CreateColmap_MPIAIJ_Private(mat);
<a name="line47"> 47: </a>  }
<a name="line48"> 48: </a>  <font color="#B22222">/*</font>
<a name="line49"> 49: </a><font color="#B22222">      Calls the _SeqAIJ() version of these routines to make sure it does not </font>
<a name="line50"> 50: </a><font color="#B22222">     get the reduced (by inodes) version of I and J</font>
<a name="line51"> 51: </a><font color="#B22222">  */</font>
<a name="line52"> 52: </a>  MatGetColumnIJ_SeqAIJ(aij-&gt;A,0,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,&amp;ncols,&amp;A_ci,&amp;A_cj,&amp;done);
<a name="line53"> 53: </a>  MatGetColumnIJ_SeqAIJ(aij-&gt;B,0,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,&amp;ncols,&amp;B_ci,&amp;B_cj,&amp;done);
<a name="line54"> 54: </a>
<a name="line55"> 55: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((M+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;rowhit);
<a name="line56"> 56: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((M+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;columnsforrow);

<a name="line58"> 58: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nis; i++) {
<a name="line59"> 59: </a>    <A href="../../../../../docs/manualpages/IS/ISGetLocalSize.html#ISGetLocalSize">ISGetLocalSize</A>(isa[i],&amp;n);
<a name="line60"> 60: </a>    <A href="../../../../../docs/manualpages/IS/ISGetIndices.html#ISGetIndices">ISGetIndices</A>(isa[i],&amp;is);
<a name="line61"> 61: </a>    c-&gt;ncolumns[i] = n;
<a name="line62"> 62: </a>    <font color="#4169E1">if</font> (n) {
<a name="line63"> 63: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;columns[i]);
<a name="line64"> 64: </a>      PetscLogObjectMemory(c,n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line65"> 65: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(c-&gt;columns[i],is,n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line66"> 66: </a>    } <font color="#4169E1">else</font> {
<a name="line67"> 67: </a>      c-&gt;columns[i]  = 0;
<a name="line68"> 68: </a>    }

<a name="line70"> 70: </a>    <font color="#4169E1">if</font> (ctype == IS_COLORING_LOCAL){
<a name="line71"> 71: </a>      <font color="#B22222">/* Determine the total (parallel) number of columns of this color */</font>
<a name="line72"> 72: </a>      <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(mat-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line73"> 73: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(2*<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*),&amp;ncolsonproc);
<a name="line74"> 74: </a>      disp = ncolsonproc + <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>;

<a name="line76"> 76: </a>      nn   = (<A href="../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>)n;
<a name="line77"> 77: </a>      <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Allgather.html#MPI_Allgather">MPI_Allgather</A>(&amp;nn,1,MPI_INT,ncolsonproc,1,MPI_INT,mat-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>);
<a name="line78"> 78: </a>      nctot = 0; <font color="#4169E1">for</font> (j=0; j&lt;<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>; j++) {nctot += ncolsonproc[j];}
<a name="line79"> 79: </a>      <font color="#4169E1">if</font> (!nctot) {
<a name="line80"> 80: </a>        <A href="../../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(mat,<font color="#666666">"Coloring of matrix has some unneeded colors with no corresponding rows\n"</font>);
<a name="line81"> 81: </a>      }

<a name="line83"> 83: </a>      disp[0] = 0;
<a name="line84"> 84: </a>      <font color="#4169E1">for</font> (j=1; j&lt;<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>; j++) {
<a name="line85"> 85: </a>        disp[j] = disp[j-1] + ncolsonproc[j-1];
<a name="line86"> 86: </a>      }

<a name="line88"> 88: </a>      <font color="#B22222">/* Get complete list of columns for color on each processor */</font>
<a name="line89"> 89: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nctot+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;cols);
<a name="line90"> 90: </a>      <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Allgatherv.html#MPI_Allgatherv">MPI_Allgatherv</A>(is,n,MPIU_INT,cols,ncolsonproc,disp,MPIU_INT,mat-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>);
<a name="line91"> 91: </a>      <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(ncolsonproc);
<a name="line92"> 92: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (ctype == IS_COLORING_GHOSTED){
<a name="line93"> 93: </a>      <font color="#B22222">/* Determine local number of columns of this color on this process, including ghost points */</font>
<a name="line94"> 94: </a>      nctot = n;
<a name="line95"> 95: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nctot+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;cols);
<a name="line96"> 96: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(cols,is,n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line97"> 97: </a>    } <font color="#4169E1">else</font> {
<a name="line98"> 98: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"Not provided for this <A href="../../../../../docs/manualpages/Mat/MatFDColoring.html#MatFDColoring">MatFDColoring</A> type"</font>);
<a name="line99"> 99: </a>    }

<a name="line101">101: </a>    <font color="#B22222">/*</font>
<a name="line102">102: </a><font color="#B22222">       Mark all rows affect by these columns</font>
<a name="line103">103: </a><font color="#B22222">    */</font>
<a name="line104">104: </a>    <font color="#B22222">/* Temporary option to allow for debugging/testing */</font>
<a name="line105">105: </a>    <A href="../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-matfdcoloring_slow"</font>,&amp;flg);
<a name="line106">106: </a>    <font color="#4169E1">if</font> (!flg) {<font color="#B22222">/*-----------------------------------------------------------------------------*/</font>
<a name="line107">107: </a>      <font color="#B22222">/* crude, fast version */</font>
<a name="line108">108: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(rowhit,M*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line109">109: </a>      <font color="#B22222">/* loop over columns*/</font>
<a name="line110">110: </a>      <font color="#4169E1">for</font> (j=0; j&lt;nctot; j++) {
<a name="line111">111: </a>        <font color="#4169E1">if</font> (ctype == IS_COLORING_GHOSTED) {
<a name="line112">112: </a>          col = ltog[cols[j]];
<a name="line113">113: </a>        } <font color="#4169E1">else</font> {
<a name="line114">114: </a>          col  = cols[j];
<a name="line115">115: </a>        }
<a name="line116">116: </a>        <font color="#4169E1">if</font> (col &gt;= cstart &amp;&amp; col &lt; cend) {
<a name="line117">117: </a>          <font color="#B22222">/* column is in diagonal block of matrix */</font>
<a name="line118">118: </a>          rows = A_cj + A_ci[col-cstart];
<a name="line119">119: </a>          m    = A_ci[col-cstart+1] - A_ci[col-cstart];
<a name="line120">120: </a>        } <font color="#4169E1">else</font> {
<a name="line121">121: </a><font color="#A020F0">#if defined (PETSC_USE_CTABLE)</font>
<a name="line122">122: </a>          PetscTableFind(aij-&gt;colmap,col+1,&amp;colb);<A href="../../../../../docs/manualpages/Sys/CHKERRQ.html#CHKERRQ">CHKERRQ</A>(ierr)
<a name="line123">123: </a>          colb --;
<a name="line124">124: </a><font color="#A020F0">#else</font>
<a name="line125">125: </a>          colb = aij-&gt;colmap[col] - 1;
<a name="line126">126: </a><font color="#A020F0">#endif</font>
<a name="line127">127: </a>          <font color="#4169E1">if</font> (colb == -1) {
<a name="line128">128: </a>            m = 0;
<a name="line129">129: </a>          } <font color="#4169E1">else</font> {
<a name="line130">130: </a>            rows = B_cj + B_ci[colb];
<a name="line131">131: </a>            m    = B_ci[colb+1] - B_ci[colb];
<a name="line132">132: </a>          }
<a name="line133">133: </a>        }
<a name="line134">134: </a>        <font color="#B22222">/* loop over columns marking them in rowhit */</font>
<a name="line135">135: </a>        <font color="#4169E1">for</font> (k=0; k&lt;m; k++) {
<a name="line136">136: </a>          rowhit[*rows++] = col + 1;
<a name="line137">137: </a>        }
<a name="line138">138: </a>      }

<a name="line140">140: </a>      <font color="#B22222">/* count the number of hits */</font>
<a name="line141">141: </a>      nrows = 0;
<a name="line142">142: </a>      <font color="#4169E1">for</font> (j=0; j&lt;M; j++) {
<a name="line143">143: </a>        <font color="#4169E1">if</font> (rowhit[j]) nrows++;
<a name="line144">144: </a>      }
<a name="line145">145: </a>      c-&gt;nrows[i]         = nrows;
<a name="line146">146: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nrows+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;rows[i]);
<a name="line147">147: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nrows+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;columnsforrow[i]);
<a name="line148">148: </a>      PetscLogObjectMemory(c,2*(nrows+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line149">149: </a>      nrows = 0;
<a name="line150">150: </a>      <font color="#4169E1">for</font> (j=0; j&lt;M; j++) {
<a name="line151">151: </a>        <font color="#4169E1">if</font> (rowhit[j]) {
<a name="line152">152: </a>          c-&gt;rows[i][nrows]           = j;
<a name="line153">153: </a>          c-&gt;columnsforrow[i][nrows] = rowhit[j] - 1;
<a name="line154">154: </a>          nrows++;
<a name="line155">155: </a>        }
<a name="line156">156: </a>      }
<a name="line157">157: </a>    } <font color="#4169E1">else</font> {<font color="#B22222">/*-------------------------------------------------------------------------------*/</font>
<a name="line158">158: </a>      <font color="#B22222">/* slow version, using rowhit as a linked list */</font>
<a name="line159">159: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> currentcol,fm,mfm;
<a name="line160">160: </a>      rowhit[M] = M;
<a name="line161">161: </a>      nrows     = 0;
<a name="line162">162: </a>      <font color="#B22222">/* loop over columns*/</font>
<a name="line163">163: </a>      <font color="#4169E1">for</font> (j=0; j&lt;nctot; j++) {
<a name="line164">164: </a>        <font color="#4169E1">if</font> (ctype == IS_COLORING_GHOSTED) {
<a name="line165">165: </a>          col = ltog[cols[j]];
<a name="line166">166: </a>        } <font color="#4169E1">else</font> {
<a name="line167">167: </a>          col  = cols[j];
<a name="line168">168: </a>        }
<a name="line169">169: </a>        <font color="#4169E1">if</font> (col &gt;= cstart &amp;&amp; col &lt; cend) {
<a name="line170">170: </a>          <font color="#B22222">/* column is in diagonal block of matrix */</font>
<a name="line171">171: </a>          rows = A_cj + A_ci[col-cstart];
<a name="line172">172: </a>          m    = A_ci[col-cstart+1] - A_ci[col-cstart];
<a name="line173">173: </a>        } <font color="#4169E1">else</font> {
<a name="line174">174: </a><font color="#A020F0">#if defined (PETSC_USE_CTABLE)</font>
<a name="line175">175: </a>          PetscTableFind(aij-&gt;colmap,col+1,&amp;colb);
<a name="line176">176: </a>          colb --;
<a name="line177">177: </a><font color="#A020F0">#else</font>
<a name="line178">178: </a>          colb = aij-&gt;colmap[col] - 1;
<a name="line179">179: </a><font color="#A020F0">#endif</font>
<a name="line180">180: </a>          <font color="#4169E1">if</font> (colb == -1) {
<a name="line181">181: </a>            m = 0;
<a name="line182">182: </a>          } <font color="#4169E1">else</font> {
<a name="line183">183: </a>            rows = B_cj + B_ci[colb];
<a name="line184">184: </a>            m    = B_ci[colb+1] - B_ci[colb];
<a name="line185">185: </a>          }
<a name="line186">186: </a>        }

<a name="line188">188: </a>        <font color="#B22222">/* loop over columns marking them in rowhit */</font>
<a name="line189">189: </a>        fm    = M; <font color="#B22222">/* fm points to first entry in linked list */</font>
<a name="line190">190: </a>        <font color="#4169E1">for</font> (k=0; k&lt;m; k++) {
<a name="line191">191: </a>          currentcol = *rows++;
<a name="line192">192: </a>          <font color="#B22222">/* is it already in the list? */</font>
<a name="line193">193: </a>          <font color="#4169E1">do</font> {
<a name="line194">194: </a>            mfm  = fm;
<a name="line195">195: </a>            fm   = rowhit[fm];
<a name="line196">196: </a>          } <font color="#4169E1">while</font> (fm &lt; currentcol);
<a name="line197">197: </a>          <font color="#B22222">/* not in list so add it */</font>
<a name="line198">198: </a>          <font color="#4169E1">if</font> (fm != currentcol) {
<a name="line199">199: </a>            nrows++;
<a name="line200">200: </a>            columnsforrow[currentcol] = col;
<a name="line201">201: </a>            <font color="#B22222">/* next three lines insert new entry into linked list */</font>
<a name="line202">202: </a>            rowhit[mfm]               = currentcol;
<a name="line203">203: </a>            rowhit[currentcol]        = fm;
<a name="line204">204: </a>            fm                        = currentcol;
<a name="line205">205: </a>            <font color="#B22222">/* fm points to present position in list since we know the columns are sorted */</font>
<a name="line206">206: </a>          } <font color="#4169E1">else</font> {
<a name="line207">207: </a>            <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_PLIB,<font color="#666666">"Invalid coloring of matrix detected"</font>);
<a name="line208">208: </a>          }
<a name="line209">209: </a>        }
<a name="line210">210: </a>      }
<a name="line211">211: </a>      c-&gt;nrows[i]         = nrows;
<a name="line212">212: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nrows+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;rows[i]);
<a name="line213">213: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nrows+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;columnsforrow[i]);
<a name="line214">214: </a>      PetscLogObjectMemory(c,(nrows+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line215">215: </a>      <font color="#B22222">/* now store the linked list of rows into c-&gt;rows[i] */</font>
<a name="line216">216: </a>      nrows = 0;
<a name="line217">217: </a>      fm    = rowhit[M];
<a name="line218">218: </a>      <font color="#4169E1">do</font> {
<a name="line219">219: </a>        c-&gt;rows[i][nrows]            = fm;
<a name="line220">220: </a>        c-&gt;columnsforrow[i][nrows++] = columnsforrow[fm];
<a name="line221">221: </a>        fm                           = rowhit[fm];
<a name="line222">222: </a>      } <font color="#4169E1">while</font> (fm &lt; M);
<a name="line223">223: </a>    } <font color="#B22222">/* ---------------------------------------------------------------------------------------*/</font>
<a name="line224">224: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(cols);
<a name="line225">225: </a>  }

<a name="line227">227: </a>  <font color="#B22222">/* Optimize by adding the vscale, and scaleforrow[][] fields */</font>
<a name="line228">228: </a>  <font color="#B22222">/*</font>
<a name="line229">229: </a><font color="#B22222">       vscale will contain the "diagonal" on processor scalings followed by the off processor</font>
<a name="line230">230: </a><font color="#B22222">  */</font>
<a name="line231">231: </a>  <font color="#4169E1">if</font> (ctype == IS_COLORING_LOCAL) {
<a name="line232">232: </a>    <A href="../../../../../docs/manualpages/Vec/VecCreateGhost.html#VecCreateGhost">VecCreateGhost</A>(mat-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,aij-&gt;A-&gt;rmap.n,<A href="../../../../../docs/manualpages/Sys/PETSC_DETERMINE.html#PETSC_DETERMINE">PETSC_DETERMINE</A>,aij-&gt;B-&gt;cmap.n,aij-&gt;garray,&amp;c-&gt;vscale);
<a name="line233">233: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(c-&gt;ncolors*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*),&amp;c-&gt;vscaleforrow);
<a name="line234">234: </a>    <font color="#4169E1">for</font> (k=0; k&lt;c-&gt;ncolors; k++) {
<a name="line235">235: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((c-&gt;nrows[k]+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;vscaleforrow[k]);
<a name="line236">236: </a>      <font color="#4169E1">for</font> (l=0; l&lt;c-&gt;nrows[k]; l++) {
<a name="line237">237: </a>        col = c-&gt;columnsforrow[k][l];
<a name="line238">238: </a>        <font color="#4169E1">if</font> (col &gt;= cstart &amp;&amp; col &lt; cend) {
<a name="line239">239: </a>          <font color="#B22222">/* column is in diagonal block of matrix */</font>
<a name="line240">240: </a>          colb = col - cstart;
<a name="line241">241: </a>        } <font color="#4169E1">else</font> {
<a name="line242">242: </a>          <font color="#B22222">/* column  is in "off-processor" part */</font>
<a name="line243">243: </a><font color="#A020F0">#if defined (PETSC_USE_CTABLE)</font>
<a name="line244">244: </a>          PetscTableFind(aij-&gt;colmap,col+1,&amp;colb);
<a name="line245">245: </a>          colb --;
<a name="line246">246: </a><font color="#A020F0">#else</font>
<a name="line247">247: </a>          colb = aij-&gt;colmap[col] - 1;
<a name="line248">248: </a><font color="#A020F0">#endif</font>
<a name="line249">249: </a>          colb += cend - cstart;
<a name="line250">250: </a>        }
<a name="line251">251: </a>        c-&gt;vscaleforrow[k][l] = colb;
<a name="line252">252: </a>      }
<a name="line253">253: </a>    }
<a name="line254">254: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (ctype == IS_COLORING_GHOSTED) {
<a name="line255">255: </a>    <font color="#B22222">/* Get gtol mapping */</font>
<a name="line256">256: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> N = mat-&gt;cmap.N, *gtol;
<a name="line257">257: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((N+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;gtol);
<a name="line258">258: </a>    <font color="#4169E1">for</font> (i=0; i&lt;N; i++) gtol[i] = -1;
<a name="line259">259: </a>    <font color="#4169E1">for</font> (i=0; i&lt;map-&gt;n; i++) gtol[ltog[i]] = i;
<a name="line260">260: </a>
<a name="line261">261: </a>    c-&gt;vscale = 0; <font color="#B22222">/* will be created in <A href="../../../../../docs/manualpages/MatFD/MatFDColoringApply.html#MatFDColoringApply">MatFDColoringApply</A>() */</font>
<a name="line262">262: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(c-&gt;ncolors*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*),&amp;c-&gt;vscaleforrow);
<a name="line263">263: </a>    <font color="#4169E1">for</font> (k=0; k&lt;c-&gt;ncolors; k++) {
<a name="line264">264: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((c-&gt;nrows[k]+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;c-&gt;vscaleforrow[k]);
<a name="line265">265: </a>      <font color="#4169E1">for</font> (l=0; l&lt;c-&gt;nrows[k]; l++) {
<a name="line266">266: </a>        col = c-&gt;columnsforrow[k][l];      <font color="#B22222">/* global column index */</font>
<a name="line267">267: </a>        c-&gt;vscaleforrow[k][l] = gtol[col]; <font color="#B22222">/* local column index */</font>
<a name="line268">268: </a>      }
<a name="line269">269: </a>    }
<a name="line270">270: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(gtol);
<a name="line271">271: </a>  }
<a name="line272">272: </a>  <A href="../../../../../docs/manualpages/IS/ISColoringRestoreIS.html#ISColoringRestoreIS">ISColoringRestoreIS</A>(iscoloring,&amp;isa);

<a name="line274">274: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(rowhit);
<a name="line275">275: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(columnsforrow);
<a name="line276">276: </a>  MatRestoreColumnIJ_SeqAIJ(aij-&gt;A,0,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,&amp;ncols,&amp;A_ci,&amp;A_cj,&amp;done);
<a name="line277">277: </a>  MatRestoreColumnIJ_SeqAIJ(aij-&gt;B,0,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,&amp;ncols,&amp;B_ci,&amp;B_cj,&amp;done);
<a name="line278">278: </a>  <font color="#4169E1">return</font>(0);
<a name="line279">279: </a>}






</pre>
</body>

</html>
